#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2000three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 2000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2000three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three20004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three20004xi = {
                1:'0x1941y-480z',
                2:'0x39y-1999z',
                3:'101x1943y-461z',
                4:'103x81y-1995z',
                5:'1051x1302y-1095z',
                6:'1075x1428y-896z',
                7:'1079x1662y-264z',
                8:'1081x1543y-668z',
                9:'111x537y-1923z',
                10:'1124x1253y-1078z',
                11:'114x209y-1985z',
                12:'1154x1376y-878z',
                13:'1164x1490y-650z',
                14:'1166x1605y-244z',
                15:'116x1674y-1087z',
                16:'1196x1200y-1061z',
                17:'1230x1321y-860z',
                18:'123x87y-1994z',
                19:'1245x1432y-631z',
                20:'1250x1544y-225z',
                21:'1265x1143y-1044z',
                22:'1304x1260y-842z',
                23:'1322x1369y-612z',
                24:'1331x1081y-1027z',
                25:'1331x1478y-205z',
                26:'135x220y-1983z',
                27:'1374x1196y-824z',
                28:'1394x1016y-1010z',
                29:'1396x1302y-592z',
                30:'13x98y-1997z',
                31:'1408x1408y-185z',
                32:'143x549y-1917z',
                33:'1441x1127y-806z',
                34:'1467x1231y-573z',
                35:'1481x1333y-165z',
                36:'1505x1055y-787z',
                37:'1534x1156y-554z',
                38:'1550x1255y-145z',
                39:'157x1801y-853z',
                40:'158x229y-1980z',
                41:'1597x1077y-535z',
                42:'1614x1173y-125z',
                43:'166x1611y-1336z',
                44:'178x559y-1911z',
                45:'182x236y-1977z',
                46:'19x25y-1999z',
                47:'1x59y-1999z',
                48:'203x1939y-441z',
                49:'205x1676y-1070z',
                50:'207x241y-1974z',
                51:'214x567y-1905z',
                52:'22x117y-1996z',
                53:'22x490y-1938z',
                54:'233x244y-1971z',
                55:'240x1536y-1256z',
                56:'251x572y-1899z',
                57:'252x1799y-835z',
                58:'260x245y-1967z',
                59:'287x244y-1964z',
                60:'289x575y-1893z',
                61:'28x1667y-1104z',
                62:'294x1674y-1053z',
                63:'305x1930y-422z',
                64:'315x240y-1960z',
                65:'323x1534y-1241z',
                66:'328x576y-1886z',
                67:'32x135y-1995z',
                68:'33x40y-1999z',
                69:'343x234y-1956z',
                70:'348x1791y-817z',
                71:'368x574y-1880z',
                72:'383x1666y-1036z',
                73:'406x1527y-1225z',
                74:'407x1916y-402z',
                75:'408x569y-1873z',
                76:'443x1778y-799z',
                77:'449x561y-1866z',
                78:'45x152y-1993z',
                79:'473x1654y-1019z',
                80:'489x1515y-1209z',
                81:'48x52y-1998z',
                82:'490x551y-1858z',
                83:'508x1896y-383z',
                84:'50x507y-1933z',
                85:'531x538y-1851z',
                86:'538x1760y-780z',
                87:'562x1636y-1002z',
                88:'572x1499y-1193z',
                89:'573x521y-1843z',
                90:'607x1870y-363z',
                91:'60x168y-1991z',
                92:'613x502y-1835z',
                93:'62x1798y-871z',
                94:'632x1737y-762z',
                95:'651x1614y-984z',
                96:'654x480y-1827z',
                97:'655x1477y-1177z',
                98:'65x64y-1997z',
                99:'693x456y-1819z',
                100:'6x79y-1998z',
                101:'6x9y-1999z',
                102:'706x1839y-343z',
                103:'725x1708y-743z',
                104:'736x1451y-1161z',
                105:'738x1586y-967z',
                106:'76x183y-1990z',
                107:'79x523y-1928z',
                108:'802x1802y-324z',
                109:'817x1421y-1145z',
                110:'817x1675y-725z',
                111:'825x1554y-949z',
                112:'83x73y-1996z',
                113:'897x1386y-1128z',
                114:'897x1761y-304z',
                115:'907x1636y-706z',
                116:'910x1517y-932z',
                117:'94x197y-1987z',
                118:'974x1346y-1112z',
                119:'989x1714y-284z',
                120:'993x1475y-914z',
                121:'995x1592y-687z'}         
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2000three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire2000three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2000THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2000THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2000THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2000THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2000THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three20004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2000THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2000THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2000THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three20004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three20004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2000THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2000THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2000THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2000three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                